Bug 1686582 - Incorrect handling of fragmented KeyUpdate messages
Summary: Incorrect handling of fragmented KeyUpdate messages
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 8
Classification: Red Hat
Component: gnutls
Version: 8.0
Hardware: Unspecified
OS: Unspecified
medium
medium
Target Milestone: rc
: 8.0
Assignee: Daiki Ueno
QA Contact: Ondrej Moriš
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-03-07 18:26 UTC by Hubert Kario
Modified: 2019-11-05 22:26 UTC (History)
3 users (show)

Fixed In Version: gnutls-3.6.8-1.el8
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-11-05 22:26:20 UTC
Type: Bug
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Gitlab gnutls/gnutls/issues/699 None None None 2019-03-07 18:28:07 UTC
Red Hat Bugzilla 1673975 None VERIFIED gnutls does not support multiple KeyUpdate messages on a connection 2019-10-18 11:42:51 UTC
Red Hat Product Errata RHSA-2019:3600 None None None 2019-11-05 22:26:42 UTC

Internal Links: 1673975

Description Hubert Kario 2019-03-07 18:26:52 UTC
Description of problem:
KeyUpdate messages interleaved with ApplicationData are not rejected by gnutls. 
This is a RFC 8446 section 5.1 violation:

   -  Handshake messages MUST NOT be interleaved with other record
      types.  That is, if a handshake message is split over two or more
      records, there MUST NOT be any other records between them.

Version-Release number of selected component (if applicable):
gnutls-3.6.5-2.el8.x86_64

How reproducible:
always

Steps to Reproduce:
1. run tlsfuzzer test-tls13-keyupdate.py test script against gnutls server

Actual results:
among failing tests there are
  '1/4 fragmented keyupdate msg, appdata between'
  '2/3 fragmented keyupdate msg, appdata between'
  '3/2 fragmented keyupdate msg, appdata between'
  '4/1 fragmented keyupdate msg, appdata between'

Expected results:
the above tests should not be listed as failing

Additional info:
there are also issues in handling split GET messages and multiple KeyUpdates in succession, but they are not directly related to this issue

Comment 13 errata-xmlrpc 2019-11-05 22:26:20 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2019:3600


Note You need to log in before you can comment on or make changes to this bug.